-- Font Manipulator version 1.0
-- Dragon Font (yes, because if it was font.e, someone could make confusion :-)
-- .DFD - DragonFont Doc
include image.e

global sequence ALPHABET
ALPHABET=repeat(0,255)

function grow_deep(sequence data, integer y_size, integer x_size)
	integer index
	sequence new
	index=1
	new=repeat(0,y_size)
	for times=1 to length(new) do
		new[times]=repeat(0,x_size)
	end for
	for times=1 to y_size do
		for again=1 to x_size do
			new[times][again]=data[index]
			index=index+1
		end for
	end for
	return new
end function

global procedure save_font(sequence data, sequence filename)
	-- data contains a bitmap to each 255 characters of ascII
	atom filenumber
	sequence temp
	sequence size

	size={length(data[1][1]),length(data[1])} -- x/y

	temp=repeat(0,size[2])
	for times=1 to length(temp) do
		temp[times]=repeat(0,size[1])
	end for

	filenumber=open(filename,"w")
	puts(filenumber,size[1])
	puts(filenumber,size[2])

	for times=1 to length(data) do
		if atom(data[times]) then
			data[times]=temp
		end if
	end for

	for times=1 to length(data) do
		for again=1 to length(data[times]) do
			puts(filenumber,data[times][again])
		end for
	end for

	close(filenumber)

	-- file structure is
	-- x size
	-- y size
	-- data
end procedure

global procedure load_font(sequence filename)
	atom filenumber
	sequence temp, blank
	object junk
	integer x_size, y_size

	temp={}
	filenumber=open(filename,"r")
	junk=getc(filenumber)
	x_size=junk
	junk=getc(filenumber)
	y_size=junk

	blank=repeat(0,x_size*y_size)
	blank=grow_deep(blank,y_size,x_size)

	for times=1 to 255 do
		temp={}
		for again=1 to x_size*y_size do
			temp=append(temp,getc(filenumber))
		end for
		ALPHABET[times]=grow_deep(temp,y_size,x_size)
	end for

	close(filenumber)
	ALPHABET[32]=blank
end procedure

global procedure make_font_from_bitmaps(sequence filenames, sequence filename)
	sequence bitmaps, temp

	bitmaps=repeat(0,255)
	for times=1 to length(filenames) do
		if atom(filenames[times]) then
			bitmaps[times]=0
		elsif sequence(filenames[times]) then
			temp=read_bitmap(filenames[times])
			temp=temp[2]
			bitmaps[times]=temp
		end if
	end for

	save_font(bitmaps,filename)
end procedure

function get_char(integer index, object color, object backcolor)
	sequence character
	character=ALPHABET[index]

	if atom(color) then
		for times=1 to length(character) do
			for again=1 to length(character[times]) do
				if character[times][again]!=0 then
					character[times][again]=color
				end if
			end for
		end for
	else
		if sequence(color[1]) then
			for times=1 to length(character) do
				for again=1 to length(character[times]) do
					if character[times][again]!=0 then
						character[times][again]=color[times][again]
					end if
				end for
			end for
		elsif integer(color[1]) then
			for times=1 to length(character) do
				for again=1 to length(character[times]) do
					if character[times][again]!=0 then
						character[times][again]=color[times]
					end if
				end for
			end for
		end if
	end if

	if atom(backcolor) then
		for times=1 to length(character) do
			for again=1 to length(character[times]) do
				if character[times][again]=0 then
					character[times][again]=backcolor
				end if
			end for
		end for
	else
		if sequence(backcolor[1]) then
			for times=1 to length(character) do
				for again=1 to length(character[times]) do
					if character[times][again]=0 then
						character[times][again]=backcolor[times][again]
					end if
				end for
			end for
		elsif integer(backcolor[1]) then
			for times=1 to length(character) do
				for again=1 to length(character[times]) do
					if character[times][again]=0 then
						character[times][again]=backcolor[times]
					end if
				end for
			end for
		end if
	end if

	return character
end function

global procedure print_sequence(sequence place, sequence data, object color, object backcolor, integer status)
	sequence temp, junk
	for times=1 to length(data) do
		temp=get_char(data[times],color,backcolor)
		if status=1 then
			if data[times]!=32 then
				junk=place
				for again=1 to length(temp) do
					for reagain=1 to length(temp[again]) do
						if temp[again][reagain]!=backcolor then
							pixel(temp[again][reagain],junk)
						end if
						junk[1]=junk[1]+1
					end for
					junk[1]=place[1]
					junk[2]=junk[2]+1
				end for
				place[1]=place[1]+length(temp[1])
			else
				place[1]=place[1]+length(temp[1])
			end if
		elsif status=0 then
			display_image(place, temp)
			place[1]=place[1]+length(temp[1])
		end if
	end for
end procedure
