-- easy menu interface version 1.0
-- by DragonZeo Soft

include graphics.e
include drfont.e

global sequence MENUS, MENU_BACKS
-- menus structures are:
-- menu[x]={menu_name, menu_items, font_color, backfont_color, window_color, around_color, menu_place, x_font_size, y_font_size, status}
-- menu_backs[x]={place, data}
MENUS=repeat(0,5000) -- 5000 menus
MENU_BACKS=repeat(0,5000) -- 5000 backgrounds

global procedure allocate_menu(integer index, sequence menu_name, sequence menu_items, sequence colors, sequence font_size)
	object font_color, backfont_color, window_color, around_color, x_font_size, y_font_size

	font_color=colors[1]
	backfont_color=colors[2]
	window_color=colors[3]
	around_color=colors[4]

	x_font_size=font_size[1]
	y_font_size=font_size[2]

	MENUS[index]={menu_name, menu_items, font_color, backfont_color, window_color, around_color, {0,0}, x_font_size, y_font_size, 0}
end procedure

procedure save_backmenu(integer index, sequence place, sequence font_size)
	sequence end_place, temp

	end_place={place[1]+length(MENUS[index][2][1])*font_size[1]+4, place[2]+(length(MENUS[index][2])+1)*font_size[2]+4}
	temp=save_image(place,end_place)
	MENU_BACKS[index]={place,temp}
end procedure

global procedure put_menu(integer index, sequence place)
	MENUS[index][10]=1 -- being display status is true
	save_backmenu(index, place, {MENUS[index][8], MENUS[index][9]})
	print_sequence(place, MENUS[index][1], MENUS[index][3], MENUS[index][4], 0)
	MENUS[index][7]=place
end procedure

global procedure clear_menu(integer index)
	display_image(MENU_BACKS[index][1],MENU_BACKS[index][2])
	MENUS[index][10]=0
end procedure

global procedure delete_menu(integer index)
	MENU_BACKS[index]=0
end procedure

global procedure put_pop_menu(integer index)
	sequence place,items
	object color, backcolor
	integer window, background
	integer x_font_size, y_font_size

	items=MENUS[index][2]
	place=MENUS[index][7]
	color=MENUS[index][3]
	backcolor=MENUS[index][4]
	window=MENUS[index][5]
	background=MENUS[index][6]
	x_font_size=MENUS[index][8]
	y_font_size=MENUS[index][9]

	place[2]=place[2]+y_font_size
	polygon(window,0,{place,{place[1]+x_font_size*length(items[1])+3,place[2]},
				{place[1]+x_font_size*length(items[1])+3,4+place[2]+y_font_size*length(items)},
				{place[1],4+place[2]+y_font_size*length(items)},
				place})
	place=place+1
	polygon(background,1,{place,{place[1]+x_font_size*length(items[1])+1,place[2]},
				{place[1]+x_font_size*length(items[1])+1,2+place[2]+y_font_size*length(items)},
				{place[1],2+place[2]+y_font_size*length(items)},
				place})
	place=place+1
	for times=1 to length(items) do
		print_sequence(place,items[times],color,backcolor,1)
		place[2]=place[2]+y_font_size
	end for
end procedure

global function get_clicked_menu(sequence mouse_place)
	sequence place, endplace
	for times=1 to length(MENUS) do
		if sequence(MENUS[times]) then
			if MENUS[times][10]=1 then
				place=MENUS[times][7]
				endplace={place[1]+length(MENUS[times][1])*MENUS[times][8],
						place[2]+MENUS[times][9]}
				if mouse_place[1]>=place[1] then
					if mouse_place[1]<=endplace[1] then
						if mouse_place[2]>=place[2] then
							if mouse_place[2]<=endplace[2] then
								return times -- index of menu clicked
							end if
						end if
					end if
				end if
			end if
		end if
	end for
	return 0 -- no clicked menu
end function

global function get_clicked_item(integer index, sequence mouse_place) -- menu needs to be popped up!
	sequence init, endit
	sequence places, items, place
	integer x_size, y_size
	place=MENUS[index][7]
	items=MENUS[index][2]
	x_size=MENUS[index][8]
	y_size=MENUS[index][9]
	place[2]=place[2]+y_size
	places={}
	for times=1 to length(items) do
		places=append(places,{place, {place[1]+length(items[1])*x_size+4, place[2]+y_size}})
		place[2]=place[2]+y_size
	end for
	for times=1 to length(places) do
		init=places[times][1]
		endit=places[times][2]
		if mouse_place[1]>=init[1] then
			if mouse_place[1]<=endit[1] then
				if mouse_place[2]>=init[2] then
					if mouse_place[2]<=endit[2] then
						return times -- index of item
					end if
				end if
			end if
		end if
	end for

	return 0 -- no clicked item
end function

-- library to simple button support
-- easybutton 1.1
include image.e
include mouse.e
include get.e

global sequence buttons,backbuttons
-- buttons[x]={image1,image2,start_place,end_place,display_status}
buttons=repeat(0,5000)
backbuttons=repeat(0,5000)

global procedure allocate_button(integer index, sequence bitmap1, sequence bitmap2)
	buttons[index]={bitmap1,bitmap2,{0,0},{0,0},0}
end procedure

global procedure deallocate_button(integer index)
	buttons[index]=0
end procedure

global procedure put_button(integer index, sequence place)
	backbuttons[index]=save_image(place,{place[1]+length(buttons[index][1][1]),place[2]+length(buttons[index][1])})
	display_image(place,buttons[index][1])
	buttons[index][5]=1 -- display_status is set to true
	buttons[index][3]=place
	buttons[index][4][1]=place[1]+length(buttons[index][1][1])
	buttons[index][4][2]=place[2]+length(buttons[index][1])
end procedure

global procedure clear_button(integer index)
	display_image(buttons[index][3],backbuttons[index])
	buttons[index][5]=0 -- display_status is set to zero
end procedure

global function check_buttons(sequence mouse_place)
	sequence init,endit
	for times=1 to length(buttons) do
		if sequence(buttons[times]) then
			if buttons[times][5]=1 then
				init=buttons[times][3]
				endit=buttons[times][4]
				if mouse_place[1]>init[1] then
					if mouse_place[1]<endit[1] then
						if mouse_place[2]>init[2] then
							if mouse_place[2]<endit[2] then
								display_image(init,buttons[times][2])
								return times -- index of clicked button
							end if
						end if
					end if
				end if
			end if
		end if
	end for

	return 0 -- none clicked
end function

global procedure refresh_buttons()
	for times=1 to length(buttons) do
		if sequence(buttons[times]) then
			if buttons[times][5]=1 then
				display_image(buttons[times][3],buttons[times][1])
			end if
		end if
	end for
end procedure

global function get_buttons(sequence data)
	-- buttons[x]={index,place}
	integer key,clicked
	object misc
	sequence mouse_place
	for times=1 to length(data) do
		put_button(data[times][1],data[times][2])
	end for
	mouse_pointer(0)
	mouse_pointer(1)
	while 1 do
		key=get_key()
		if key!=-1 then
			return key
		end if
		misc=get_mouse()
		if sequence(misc) then
			if misc[1]=2 then -- left mouse click
				mouse_place={misc[2]/2,misc[3]}
				mouse_pointer(0)
				clicked=check_buttons(mouse_place)
				mouse_pointer(1)
			elsif misc[1]=4 then -- left released
				mouse_place={misc[2]/2,misc[3]}
				mouse_pointer(0)
				clicked=check_buttons(mouse_place)
				refresh_buttons()
				if clicked!=0 then
					return clicked
				end if
				mouse_pointer(1)
			end if
		end if
	end while
	return 0
end function

global function get_event()
	sequence mouse_place, temp_place
	object check, temp
	integer test, junk, test_button
	sequence event

	test_button=0
	test=0
	event={}
	check=get_mouse()
	if sequence(check) then
		mouse_place={check[2]/2,check[3]}
		if and_bits(check[1],2) then -- left click
			test=get_clicked_menu(mouse_place)
			if test!=0 then
				mouse_pointer(0)
				put_pop_menu(test)
				mouse_pointer(1)
				while 1 do
					temp=get_mouse()
					if sequence(temp) then
						mouse_place={temp[2]/2,temp[3]}
						if and_bits(temp[1],2) then
							junk=get_clicked_item(test,mouse_place)
							if junk!=0 then
								mouse_pointer(0)
								temp_place=MENUS[test][7]
								clear_menu(test)
								put_menu(test,temp_place)
								mouse_pointer(1)
								event={1,test,junk,0} -- clicked menu test, option junk
								return event
							else
								mouse_pointer(0)
								temp_place=MENUS[test][7]
								clear_menu(test)
								put_menu(test,temp_place)
								mouse_pointer(1)
								exit
							end if
						end if
					end if
				end while
			end if

			mouse_pointer(0)
			test_button=check_buttons(mouse_place)
			mouse_pointer(1)
			if test_button=0 then
				return check -- return get_mouse() kind sequence
			else
				while 1 do
					temp=get_mouse()
					if sequence(temp) then
						if and_bits(temp[1],4) then -- released button
							temp_place={temp[2]/2,temp[3]}
							mouse_pointer(0)
							test_button=check_buttons(temp_place)
							mouse_pointer(1)
							if test_button=0 then
								mouse_pointer(0)
								refresh_buttons()
								mouse_pointer(1)
								return check -- return sequence like get_mouse()
							else
								mouse_pointer(0)
								refresh_buttons()
								mouse_pointer(1)
								event={2,test_button}
								return event -- return sequence clicked button, the button
							end if
						end if
					end if
				end while
			end if
		end if
	end if

	return check
end function
